unit ufrmMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, usgmEditListBox, Buttons, ExtCtrls;

type
  TfrmMain = class(TForm)
    EditListBox: TSGMEditListBox;
    SpeedButton1: TSpeedButton;
    Label1: TLabel;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    Bevel2: TBevel;
    cbReadOnly: TCheckBox;
    rgAutoOptions: TRadioGroup;
    cbMultiSelect: TCheckBox;
    cbaoDelete: TCheckBox;
    cbaoEdit: TCheckBox;
    cbaoEditOnDblClick: TCheckBox;
    cbaoInsert: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure cbReadOnlyClick(Sender: TObject);
    procedure cbMultiSelectClick(Sender: TObject);
    procedure cbaoDeleteClick(Sender: TObject);
    procedure cbaoEditClick(Sender: TObject);
    procedure cbaoEditOnDblClickClick(Sender: TObject);
    procedure cbaoInsertClick(Sender: TObject);
    procedure EditListBoxEndEditItem(Sender: TObject; Index: Integer;
      var NewText: String; const OriginalText: String;
      var EndEdit: Boolean);
    procedure EditListBoxBeginEditItem(Sender: TObject; Index: Integer;
      var CanEdit: Boolean; var SelStart, SelLength: Integer);
  private
    procedure SetEditListBox_AutoOption(IsSet: Boolean; Option: TSGMAutoOption);
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  EditListBox.ItemIndex := 0;
end;

procedure TfrmMain.SpeedButton1Click(Sender: TObject);
begin
  EditListBox.DoBeginEditItem;
end;

procedure TfrmMain.SpeedButton2Click(Sender: TObject);
begin
  EditListBox.InsertItemBefore;
end;

procedure TfrmMain.SpeedButton3Click(Sender: TObject);
begin
  EditListBox.InsertItemAfter;
end;

procedure TfrmMain.SpeedButton4Click(Sender: TObject);
begin
  EditListBox.DeleteItem( EditListBox.ItemIndex );
end;

procedure TfrmMain.cbReadOnlyClick(Sender: TObject);
begin
  EditListBox.ReadOnly := cbReadOnly.Checked;
  if cbReadOnly.Checked then
    cbReadOnly.Font.Style := [fsBold]
  else
    cbReadOnly.Font.Style := [];
  EditListBox.SetFocus;
end;

procedure TfrmMain.cbMultiSelectClick(Sender: TObject);
begin
  EditListBox.MultiSelect := cbMultiSelect.Checked;
end;

procedure TfrmMain.SetEditListBox_AutoOption(IsSet: Boolean; Option: TSGMAutoOption);
begin
  if IsSet then
    EditListBox.AutoOptions := EditListBox.AutoOptions + [Option]
  else
    EditListBox.AutoOptions := EditListBox.AutoOptions - [Option];
  EditListBox.SetFocus;
end;

procedure TfrmMain.cbaoDeleteClick(Sender: TObject);
begin
  SetEditListBox_AutoOption(cbaoDelete.Checked, aoDelete);
end;

procedure TfrmMain.cbaoEditClick(Sender: TObject);
begin
  SetEditListBox_AutoOption(cbaoEdit.Checked, aoEdit);
end;

procedure TfrmMain.cbaoEditOnDblClickClick(Sender: TObject);
begin
  SetEditListBox_AutoOption(cbaoEditOnDblClick.Checked, aoEditOnDblClick);
end;

procedure TfrmMain.cbaoInsertClick(Sender: TObject);
begin
  SetEditListBox_AutoOption(cbaoInsert.Checked, aoInsert);
end;

procedure TfrmMain.EditListBoxEndEditItem(Sender: TObject; Index: Integer;
  var NewText: String; const OriginalText: String; var EndEdit: Boolean);
begin
  if Application.MessageBox(
    'Rename this file?',
    'Question',
    MB_YESNO or MB_ICONQUESTION
  ) = ID_NO then NewText := OriginalText;
end;

procedure TfrmMain.EditListBoxBeginEditItem(Sender: TObject;
  Index: Integer; var CanEdit: Boolean; var SelStart, SelLength: Integer);
var
  S: String;
begin
  S := EditListBox.Items[ Index ];
  S := ChangeFileExt( S, '' );
  SelLength := Length( S );
end;

end.
